#include <FastLED.h> //We are going to use the FastLED library
#define EXERCISE_3 //The programm that you want to upload
#define NUM_LEDS 24 //the amount of LEDs that are used on the Whadda XL kit
#define STRING1_PIN 2 //The pin on which the led string is connected

CRGBArray<NUM_LEDS> leds; //Defining the array of the LEDs;


void setup() {
  FastLED.addLeds<WS2812B, STRING1_PIN>(leds, NUM_LEDS);  //Tell the FastLED library that we are using WS2812B LEDs
  //STRING1_PIN => The pin on which the LED string is connected
  //leds => The array which FastLED will modify
  //NUM_LEDS => Amount of LEDs
  FastLED.setBrightness(100); //The max brightness value is 255
}

#ifdef BASE //Base program; each LED will light up one at a time, in the color blue
void loop() { //Begin Loop forever
  for (int i = 0; i < NUM_LEDS; i++) {//We will count to 24 starting from 0, and will add 1 for every loop and check if we have reached the end, 'i' will increment with 1 each time
    FastLED.clear(); //Set all LEDs to black
    leds[i] = CRGB::Blue;//The LED at position 'i' should light up in blue
    FastLED.show();//Show the current state of the LEDs array
    delay(500);// Wait for 500 miliseconds
  }
}
#endif

#ifdef EXERCISE_1 //Change the color to green
void loop() {
  for (int i = 0; i < NUM_LEDS; i++) {
    FastLED.clear();
    leds[i] = CRGB::Green;
    FastLED.show();
    delay(500);
  }
}
#endif

#ifdef EXERCISE_2 //Change the color of each LED based on the position of that LED
void loop() {
  for (int i = 0; i < NUM_LEDS; i++) {
    FastLED.clear();
    leds[i] = CHSV(i * 10, 255, 255); //Change the Hue value (24*10 = 240)
    FastLED.show();
    delay(500);
  }
}
#endif

#ifdef EXERCISE_3 //Change the speed, make the LEDs move slower or faster
void loop() {
  for (int i = 0; i < NUM_LEDS + 1; i++) {
    FastLED.clear();
    leds[i] = CHSV(i * 10, 255, 255);
    FastLED.show();
    delay(100);
  }
}
#endif
