#include <FastLED.h> //We zullen de FastLED bibliotheek gebruiken
#define OEFENING_3 //De oefening die je wilt uploaden
#define NUM_LEDS 24 //Hoeveel LEDs er op de WHADDA XL kit aanwezig zijn
#define STRING1_PIN 2 //Op welke pin van de Arduino is de LED string geconnecteerd

CRGBArray<NUM_LEDS> leds; //We definieeren de array van LEDs;


void setup() {
  FastLED.addLeds<WS2812B, STRING1_PIN>(leds, NUM_LEDS);  //We gebruiken LED type WS2812B LEDs
  //STRING1_PIN => Op welke pin van de Arduino is de LED string geconnecteerd
  //leds => We definieeren de array van LEDs
  //NUM_LEDS => Aantal LEDs
  FastLED.setBrightness(100); //De maximum helderheid waarde is 255
}

#ifdef BASIS //Basis programma; de LEDs lichten één voor één op in blauw
void loop() { //Start de oefening, oneindig
  for (int i = 0; i < NUM_LEDS; i++) {//We tellen van 0 tot en met 24, 'i'zal telkens met 1 toenemen
    FastLED.clear(); //Zet alle LEDs uit
    leds[i] = CRGB::Blue;//Laat de LED op positie 'i' blauw oplichten
    FastLED.show();//Toon de huidige staat van de leds array
    delay(500);//Wacht voor 500 miliseconden
  }
}
#endif

#ifdef EXERCISE_1 //Verander het kleur van blauw naar groen (gebruik het engelse woord 'green')
void loop() {
  for (int i = 0; i < NUM_LEDS; i++) {
    FastLED.clear();
    leds[i] = CRGB::Green;
    FastLED.show();
    delay(500);
  }
}
#endif

#ifdef EXERCISE_2 //Zorg ervoor dat elke LED een andere kleur weergeeft
void loop() {
  for (int i = 0; i < NUM_LEDS; i++) {
    FastLED.clear();
    leds[i] = CHSV(i * 10, 255, 255); //Verander de Hue waarde (24*10 = 240)
    FastLED.show();
    delay(500);
  }
}
#endif

#ifdef EXERCISE_3 //Verander de snelheid
void loop() {
  for (int i = 0; i < NUM_LEDS + 1; i++) {
    FastLED.clear();
    leds[i] = CHSV(i * 10, 255, 255);
    FastLED.show();
    delay(100);
  }
}
#endif
